import { createVNode as _createVNode } from "vue";
// Composables
import { provideDefaults } from "../../composables/defaults.mjs"; // Utility
import { genericComponent, useRender } from "../../util/index.mjs";
export const VBannerActions = genericComponent()({
  name: 'VBannerActions',
  props: {
    color: String,
    density: String
  },
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    provideDefaults({
      VBtn: {
        color: props.color,
        density: props.density,
        variant: 'text'
      }
    });
    useRender(() => _createVNode("div", {
      "class": "v-banner-actions"
    }, [slots.default?.()]));
    return {};
  }
});
//# sourceMappingURL=VBannerActions.mjs.map