import { createVNode as _createVNode } from "vue";
// Composables
import { provideDefaults } from "../../composables/defaults.mjs"; // Utilities
import { defineComponent, useRender } from "../../util/index.mjs"; // Types
export const VCardActions = defineComponent({
  name: 'VCardActions',
  setup(_, _ref) {
    let {
      slots
    } = _ref;
    provideDefaults({
      VBtn: {
        variant: 'text'
      }
    });
    useRender(() => _createVNode("div", {
      "class": "v-card-actions"
    }, [slots.default?.()]));
    return {};
  }
});
//# sourceMappingURL=VCardActions.mjs.map