import { createVNode as _createVNode } from "vue";
// Styles
import "./VLayout.css";

// Composables
import { createLayout, makeLayoutProps } from "../../composables/layout.mjs"; // Utilities
import { genericComponent, useRender } from "../../util/index.mjs";
export const VLayout = genericComponent()({
  name: 'VLayout',
  props: makeLayoutProps(),
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    const {
      layoutClasses,
      layoutStyles,
      getLayoutItem,
      items,
      layoutRef
    } = createLayout(props);
    useRender(() => _createVNode("div", {
      "ref": layoutRef,
      "class": layoutClasses.value,
      "style": layoutStyles.value
    }, [slots.default?.()]));
    return {
      getLayoutItem,
      items
    };
  }
});
//# sourceMappingURL=VLayout.mjs.map