import { createVNode as _createVNode } from "vue";
// Styles
import "./VLocaleProvider.css";

// Composables
import { provideLocale } from "../../composables/locale.mjs"; // Utilities
import { genericComponent, useRender } from "../../util/index.mjs";
export const VLocaleProvider = genericComponent()({
  name: 'VLocaleProvider',
  props: {
    locale: String,
    fallbackLocale: String,
    messages: Object,
    rtl: {
      type: Boolean,
      default: undefined
    }
  },
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    const {
      rtlClasses
    } = provideLocale(props);
    useRender(() => _createVNode("div", {
      "class": ['v-locale-provider', rtlClasses.value]
    }, [slots.default?.()]));
    return {};
  }
});
//# sourceMappingURL=VLocaleProvider.mjs.map