import { createVNode as _createVNode } from "vue";
// Styles
import "./VThemeProvider.css";

// Composables
import { makeThemeProps, provideTheme } from "../../composables/theme.mjs";
import { makeTagProps } from "../../composables/tag.mjs"; // Utilities
import { genericComponent } from "../../util/index.mjs";
export const VThemeProvider = genericComponent()({
  name: 'VThemeProvider',
  props: {
    withBackground: Boolean,
    ...makeThemeProps(),
    ...makeTagProps()
  },
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    const {
      themeClasses
    } = provideTheme(props);
    return () => {
      if (!props.withBackground) return slots.default?.();
      return _createVNode(props.tag, {
        "class": ['v-theme-provider', themeClasses.value]
      }, {
        default: () => [slots.default?.()]
      });
    };
  }
});
//# sourceMappingURL=VThemeProvider.mjs.map