import { createVNode as _createVNode } from "vue";
// Composables
import { makeVariantProps } from "../../composables/variant.mjs";
import { provideDefaults } from "../../composables/defaults.mjs"; // Utilities
import { genericComponent, useRender } from "../../util/index.mjs";
import { toRef } from 'vue';
export const VToolbarItems = genericComponent()({
  name: 'VToolbarItems',
  props: makeVariantProps({
    variant: 'text'
  }),
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    provideDefaults({
      VBtn: {
        color: toRef(props, 'color'),
        height: 'inherit',
        variant: toRef(props, 'variant')
      }
    });
    useRender(() => _createVNode("div", {
      "class": "v-toolbar-items"
    }, [slots.default?.()]));
    return {};
  }
});
//# sourceMappingURL=VToolbarItems.mjs.map